<?php

/*
 *   PNP4NAGIOS template for check_fbox_smarthome from 2014-04-21
 *   (c) 2013,2014 by Frederic Krueger / fkrueger-dev-checkfboxsmarthome@holics.at
 *
 *   Licensed under Creative Commons Attribution-ShareAlike 3.0 Unported
 *   There is no warranty of any kind, explicit or implied, for anything this software does or does not do.
 *
 *   The accompanying software's homepage can be found here:
 *   http://dev.techno.holics.at/check_fbox_smarthome/
 *
 *   Requires: pnp4nagios
 *
 *   On my testrig, this graph template looks good in "nice" mode  most of the time; only really works nicely
 *   on data with linear distances between the datasources' datapoints though. It still beats the default template, IMO.
 *
 */

## options
$coloring = "nice";     # nice or boring, see right below..


#### DONT EDIT BELOW HERE

## coloring
$nicercolors = array (
 'dark' => array(
  'cc3118', 'cc7016', 'c9b215',  # red orange yellow
  '24bc14', '1598c3', 'b415c7',  # green blue pink
  '4d18e4',                      # purple
  'cc3118', 'cc7016', 'c9b215',  # red orange yellow
  '24bc14', '1598c3', 'b415c7',  # green blue pink
  '4d18e4'                       # purple
 ),
 'light' => array(
  'ea644a', 'ec9d48', 'ecd748',  # red orange yellow
  '54ec48', '48c4ec', 'de48ec',  # green blue pink
  '7648ec',                      # purple
  'ea644a', 'ec9d48', 'ecd748',  # red orange yellow
  '54ec48', '48c4ec', 'de48ec',  # green blue pink
  '7648ec'                       # purple
 )
);

$boringcolors = array(
  'dark' => array(
    '000000', '222222', '444444', '666666', '888888', 'aaaaaa', 'cccccc', 'eeeeee'
  ),
  'light' => array(
    '111111', '333333', '555555', '777777', '999999', 'bbbbbb', 'dddddd', 'ffffff'
  )
);


## init
$opt[1] = " --title \"Current energy usage (in W) for " . $this->MACRO['DISP_HOSTNAME'] . ' / ' . $this->MACRO['DISP_SERVICEDESC'] . "\" ";
$opt[1] .= " --slope-mode ";
$def[1] = "";

$opt[2] = " --title \"Total energy usage (in KW/h) for " . $this->MACRO['DISP_HOSTNAME'] . ' / ' . $this->MACRO['DISP_SERVICEDESC'] . "\" ";
$opt[2] .= " --slope-mode ";
$def[2] = "";


## main
$usedcolors = ($coloring == "nice" ? $nicercolors : $boringcolors);

function gettrans ($name = "")
{
  $transtable = array(
    '_status' => array(
      'unit' => '0=off,1=on',
      'ratio' => 'INF',
      'prtformat' => '%1.0lf',
      'prtformatshort' => '%1.0lf'
    ),
    '_actual' => array(
      'unit' => 'KW',
      'ratio' => 1000,
      'prtformat' => '%7.5lf',
      'prtformatshort' => '%6.4lf'
    ),
    '_energy' => array(
      'unit' => 'KW',
      'ratio' => 1000,
      'prtformat' => '%7.5lf',
      'prtformatshort' => '%6.4lf'
    ),
    '_total' => array(
      'unit' => 'KW/h',
      'ratio' => 1,
      'prtformat' => '%7.3lf',
      'prtformatshort' => '%5.2lf'
    )
  );

  $unit = "";
  $ratio = 1;
  $prtformat = "%9.4lf";
  $prtformatsh = "%7.2lf";

  reset ($transtable);
  foreach ($transtable as $k => $v)
  {
    if (strpos($name, $k) !== false)
    {
      return ($v);               # specific values from transtable
    }
  }
  return (array('unit' => $unit, 'color' => '', 'ratio' => $ratio, 'prtformat' => $prtformat, 'prtformatshort' => $prtformatshort));   # defaults
}


$rrdstatus = array(
  '1defs' => array(),
  '2cdefs' => array(),
  '3areas' => array(),
  '4line1s' => array(),
  '5gprints' => array()
);
$rrdtotal = array(
  '1defs' => array(),
  '2cdefs' => array(),
  '3areas' => array(),
  '4line1s' => array(),
  '5gprints' => array()
);
$rrdcurrent = array(
  '1defs' => array(),
  '2cdefs' => array(),
  '3areas' => array(),
  '4line1s' => array(),
  '5gprints' => array()
);



$arractual = array();

$linecnt=1;
reset ($this->DS);
foreach ($this->DS as $key => $val)
{
  # _energy (ie. getswitchpower) never returns useful output.. I wonder what it's there for.. AVM doesn't tell. so we skip it.
  if (strpos($val['NAME'], "_energy") !== false) { continue; }

  $tmpinfo = gettrans ($val['NAME']);

  $ratio = $tmpinfo['ratio'];
  $unit = $tmpinfo['unit'];
  $prtformat = $tmpinfo['prtformat'];
  $prtformatsh = $tmpinfo['prtformatshort'];

  $dscolor = $usedcolors['dark'][$linecnt-1];

  $fmtlinecnt = sprintf ("%04ld", $linecnt);
  $arractual[ sprintf("%012.6f--%s", $val['ACT'], $val['NAME']) ] = "$fmtlinecnt";

  $dsname = "DP${linecnt}";
  $dsnamescaled = "DP${linecnt}S";

  if (strpos($val['NAME'], "_total") !== false)
  {
    $rrdtotal['1defs']["$fmtlinecnt"]  = sprintf ("DEF:%s=%s:%s:%s ", $dsname, $val['RRDFILE'], $val['DS'], "AVERAGE");
    $rrdtotal['2cdefs']["$fmtlinecnt"] = sprintf ("CDEF:%s=%s,%s,* ", $dsnamescaled, $dsname, $ratio);
  }
  elseif (strpos($val['NAME'], "_status") !== false)
  {
    $rrdstatus['1defs']["$fmtlinecnt"]  = sprintf ("DEF:%s=%s:%s:%s ", $dsname, $val['RRDFILE'], $val['DS'], "AVERAGE");
    $rrdstatus['2cdefs']["$fmtlinecnt"] = sprintf ("CDEF:%s=%s,%s,* ", $dsnamescaled, $dsname, $ratio);
  }
  else
  {
    $rrdcurrent['1defs']["$fmtlinecnt"]  = sprintf ("DEF:%s=%s:%s:%s ", $dsname, $val['RRDFILE'], $val['DS'], "AVERAGE");
    $rrdcurrent['2cdefs']["$fmtlinecnt"] = sprintf ("CDEF:%s=%s,%s,* ", $dsnamescaled, $dsname, $ratio);
  }

  if (strpos($val['NAME'], "_total") !== false)
  {
    $rrdtotal['3areas']["$fmtlinecnt"]  = sprintf ("AREA:%s#%s ", $dsnamescaled, $usedcolors['light'][$linecnt-1]);
    $rrdtotal['4line1s']["$fmtlinecnt"] = sprintf ("LINE1:%s#%s:\"%s\" ", $dsnamescaled, $usedcolors['dark'][$linecnt-1], $val['NAME']);
  }
  # the following is adding black background, which is not shown when the switch of the device is turned on (ie. status=1)
  elseif (strpos($val['NAME'], "_status") !== false)
  {
    $rrdstatus['2cdefs']["${fmtlinecnt}bg"] = sprintf ("CDEF:%s=%s,INF,+ ", $dsnamescaled."_bg", $dsname);
    $rrdstatus['3areas']["${fmtlinecnt}bg"] = sprintf ("AREA:%s#%s ", $dsnamescaled."_bg", "00000080");
    $rrdstatus['3areas']["${fmtlinecnt}fg"] = sprintf ("AREA:%s#%s:\"Device is on\" ", $dsnamescaled, "c0c0c080", $val['NAME']);
  }
  else
  {
    $rrdcurrent['3areas']["$fmtlinecnt"]  = sprintf ("AREA:%s#%s ", $dsnamescaled, $usedcolors['light'][$linecnt-1]);
    $rrdcurrent['4line1s']["$fmtlinecnt"] = sprintf ("LINE1:%s#%s:\"%s\" ", $dsnamescaled, $usedcolors['dark'][$linecnt-1], $val['NAME']);
  }

  if (strpos($val['NAME'], "_status") !== false)
  {
    # show nothing
  }
  elseif (strpos($val['NAME'], "_total") !== false)
  {
    $rrdtotal['5gprints']["${fmtlinecnt}1"] = sprintf ("GPRINT:%s:LAST:\"%s\: Cur %s %s\\c\" ", $dsname, $val['NAME'], $prtformat, $unit);
  }
  else
  {
    $rrdcurrent['5gprints']["${fmtlinecnt}1"] = sprintf ("GPRINT:%s:LAST:\"%s\: Cur %s  Min Avg Max\" ", $dsname, $val['NAME'], $prtformat);
    $rrdcurrent['5gprints']["${fmtlinecnt}2"] = sprintf ("GPRINT:%s:MIN:\"%s\" ", $dsname, $prtformatsh);
    $rrdcurrent['5gprints']["${fmtlinecnt}3"] = sprintf ("GPRINT:%s:AVERAGE:\"%s\" ", $dsname, $prtformatsh);
    $rrdcurrent['5gprints']["${fmtlinecnt}4"] = sprintf ("GPRINT:%s:MAX:\"%s %s\\l\" ", $dsname, $prtformatsh, $unit);
  }

  $linecnt++;
}



## now create the graphs
#
## the current one
foreach ($rrdcurrent as $k => $v)
{
  if ($k == "5gprints") { $def[1] .= "COMMENT:\"\\r\" COMMENT:\"\\r\" "; }

  ksort ($rrdstatus[$k]);
  foreach ($rrdstatus[$k] as $k2 => $v2)
  {
    $def[1] .= $v2;
  }

  ksort ($v);
  foreach ($v as $k2 => $v2)
  {
    $def[1] .= $v2;
  }
}

$def[1] .= "COMMENT:\"\\r\" ";
$def[1] .= "COMMENT:\"Command " . $val['TEMPLATE'] . " (template\: Current energy usage)\\r\" ";


## and the total one
foreach ($rrdtotal as $k => $v)
{
  if ($k == "5gprints") { $def[2] .= "COMMENT:\"\\r\" COMMENT:\"\\r\" "; }

  ksort ($rrdstatus[$k]);
  foreach ($rrdstatus[$k] as $k2 => $v2)
  {
    $def[2] .= $v2;
  }

  ksort ($v);
  foreach ($v as $k2 => $v2)
  {
    $def[2] .= $v2;
  }
}

$def[2] .= "COMMENT:\"\\r\" ";
$def[2] .= "COMMENT:\"Command " . $val['TEMPLATE'] . " (template\: Total energy usage)\\r\" ";

?>
